<?php

/*
Plugin Name: Digg Digg
Version: 3.4
Plugin URI: http://www.mkyong.com/blog/digg-digg-wordpress-plugin
Author: Yong Mook Kim
Author URI: http://www.mkyong.com/
Description: All-in-One social vote buttons - Digg, Reddit, dDone, Yahoo Buzz, TweetMeme(twitter), fbshare(facebook), Polladium, StumbleUpon, Delicious, Sphinn, Post comments and Google Buzz.

http://digg.com/tools/integrate
http://www.reddit.com/buttons/
http://in.buzz.yahoo.com/buttons
http://www.dzone.com/links/buttons.jsp
http://tweetmeme.com/about/retweet_button
http://www.fbshare.me/
http://www.polladium.com/poll-this_get_badge.php
http://www.stumbleupon.com/buttons/
http://delicious.com/help/tools
http://delicious.com/help/savebuttons
http://sphinn.com/widgets/
http://code.google.com/apis/buzz/
*/ 

/*
ini_set('display_errors',1);
error_reporting(E_ALL);
*/

//include required class
require_once 'dd.class.php';
require_once 'dd.constant.php';
require_once 'dd.printform.php';


//add digg digg table output style
function digg_digg_stylesheet_table()
{
	echo '<link rel="stylesheet" href="'. get_bloginfo('wpurl') . '/wp-content/plugins/digg-digg/';
	echo 'diggdigg-style.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

//add digg digg ul output style
function digg_digg_stylesheet_ul()
{
	echo '<link rel="stylesheet" href="'. get_bloginfo('wpurl') . '/wp-content/plugins/digg-digg/';
	echo 'diggdigg-style-ul.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

//Wordpress Hook Hook
add_action(DD_WP_ADMIN_MENU, DD_ADMIN_MENU);
add_filter(DD_WP_THE_CONTENT, DD_CONTENT_HOOK);

$html_output = get_Option(DD_OUTPUT_HTML);
if($html_output==DD_OUTPUT_HTML_UL){
	add_action(DD_WP_HEAD, 'digg_digg_stylesheet_ul');	
}else if($html_output==DD_OUTPUT_HTML_TABLE){
	add_action(DD_WP_HEAD, 'digg_digg_stylesheet_table');	
}else{
	add_action(DD_WP_HEAD, 'digg_digg_stylesheet_ul');	
}

//plugin initial during activation, reset all value
register_activation_hook( __FILE__, 'digg_digg_initialIt');

/**
 * Initial the value
 * @param $type , reset or initial , DD_FUNC_TYPE_RESET or DD_FUNC_TYPE_INITIAL
 */
function digg_digg_DataInitialer($type=DD_FUNC_TYPE_RESET){
	$dd_digg = new DD_Digg();
	$dd_reddit = new DD_Reddit();
	$dd_dzone = new DD_Dzone();
	$dd_ybuzz = new DD_YBuzz();
	$dd_twitter = new DD_Twitter();
	$dd_fbshare = new DD_FbShare();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();

	if(get_option(DD_DIGG_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DIGG_OPTIONS, $dd_digg->wp_options);
		
	if(get_option(DD_REDDIT_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_REDDIT_OPTIONS, $dd_reddit->wp_options);
		
	if(get_option(DD_DZONE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DZONE_OPTIONS, $dd_dzone->wp_options);
		
	if(get_option(DD_YBUZZ_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_YBUZZ_OPTIONS, $dd_ybuzz->wp_options);
		
	if(get_option(DD_TWITTER_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_TWITTER_OPTIONS, $dd_twitter->wp_options);
		
	if(get_option(DD_FBSHARE_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_FBSHARE_OPTIONS, $dd_fbshare->wp_options);
		
	if(get_option(DD_POLLADIUM_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_POLLADIUM_OPTIONS, $dd_polladium->wp_options);
	
	if(get_option(DD_STUMBLEUPON_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_STUMBLEUPON_OPTIONS, $dd_stumbleupon->wp_options);
	
	if(get_option(DD_DELICIOUS_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DELICIOUS_OPTIONS, $dd_delicious->wp_options);

	if(get_option(DD_SPHINN_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_SPHINN_OPTIONS, $dd_sphinn->wp_options);
		
	if(get_option(DD_COMMENTS_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_COMMENTS_OPTIONS, $dd_comments->wp_options);
	
	if(get_option(DD_GBUZZ_OPTIONS)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_GBUZZ_OPTIONS, $dd_gbuzz->wp_options);
		
	if(get_option(DD_DISPLAY_HOME)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_HOME, DD_DISPLAY_OFF);
		
	if(get_option(DD_DISPLAY_PAGE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_PAGE, DD_DISPLAY_OFF);
		
	if(get_option(DD_DISPLAY_POST)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_POST, DD_DISPLAY_ON);
		
	if(get_option(DD_DISPLAY_CATEGORY)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_CATEGORY, DD_DISPLAY_OFF);
		
	if(get_option(DD_DISPLAY_ARCHIVE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_DISPLAY_ARCHIVE, DD_DISPLAY_OFF);
	
	if(get_option(DD_LINE_UP)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_LINE_UP, DD_LINE_UP_HORIZONTAL);
	
	if(get_option(DD_OUTPUT_HTML)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_OUTPUT_HTML, DD_OUTPUT_HTML_UL);
		
	if(get_option(DD_TWITTER_SOURCE)==DD_EMPTY_VALUE || $type==DD_FUNC_TYPE_RESET)
		update_option(DD_TWITTER_SOURCE, DD_EMPTY_VALUE);
}

//reset all the value
function digg_digg_resetIt(){
	digg_digg_DataInitialer(DD_FUNC_TYPE_RESET);	
}

//initial the unset value
function digg_digg_initialIt(){
	digg_digg_DataInitialer(DD_FUNC_TYPE_INITIAL);
}

//add digg digg menu
function digg_digg_admin_menu() {
	add_submenu_page(DD_WP_OPTIONS_GENERAL, DD_OPTIONS, DD_NAME, 8, DD_NAME , DD_MENU);
}

function digg_digg_menu(){
	
	$dd_digg = new DD_Digg();
	$dd_reddit = new DD_Reddit();
	$dd_dzone = new DD_Dzone();
	$dd_ybuzz = new DD_YBuzz();
	$dd_twitter = new DD_Twitter();
	$dd_fbshare = new DD_FbShare();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	
	if (isset($_POST[DD_FORM_SAVE])) {

	    //digg.com
	    foreach(array_keys($dd_digg->wp_options) as $key){
	    	$dd_digg->wp_options[$key] = $_POST[$key];
	    }
		    
	    //reddit.com
	    foreach(array_keys($dd_reddit->wp_options) as $key){
	    	$dd_reddit->wp_options[$key] = $_POST[$key];
	    }

	    //dzone.com
		foreach(array_keys($dd_dzone->wp_options) as $key){
	    	$dd_dzone->wp_options[$key] = $_POST[$key];
	    }
	    
	    //yahoo buzz
		foreach(array_keys($dd_ybuzz->wp_options) as $key){
	    	$dd_ybuzz->wp_options[$key] = $_POST[$key];
	    }
	    
		//twitter
		foreach(array_keys($dd_twitter->wp_options) as $key){
	    	$dd_twitter->wp_options[$key] = $_POST[$key];
	    }
	    
		//facebook
		foreach(array_keys($dd_fbshare->wp_options) as $key){
	    	$dd_fbshare->wp_options[$key] = $_POST[$key];
	    }
	    
		//polladium
		foreach(array_keys($dd_polladium->wp_options) as $key){
	    	$dd_polladium->wp_options[$key] = $_POST[$key];
	    }
	
	    //stumbleupon
	    foreach(array_keys($dd_stumbleupon->wp_options) as $key){
	    	$dd_stumbleupon->wp_options[$key] = $_POST[$key];
	    }
	    
		//delicious
	    foreach(array_keys($dd_delicious->wp_options) as $key){
	    	$dd_delicious->wp_options[$key] = $_POST[$key];
	    }
	    
		//sphinn
	    foreach(array_keys($dd_sphinn->wp_options) as $key){
	    	$dd_sphinn->wp_options[$key] = $_POST[$key];
	    }
	    
		//post comments
	    foreach(array_keys($dd_comments->wp_options) as $key){
	    	$dd_comments->wp_options[$key] = $_POST[$key];
	    }
	    
		//Google Buzz
	    foreach(array_keys($dd_gbuzz->wp_options) as $key){
	    	$dd_gbuzz->wp_options[$key] = $_POST[$key];
	    }
	    
		update_option(DD_DIGG_OPTIONS, $dd_digg->wp_options);
		update_option(DD_REDDIT_OPTIONS, $dd_reddit->wp_options);
		update_option(DD_DZONE_OPTIONS, $dd_dzone->wp_options);
		update_option(DD_YBUZZ_OPTIONS, $dd_ybuzz->wp_options);
		update_option(DD_TWITTER_OPTIONS, $dd_twitter->wp_options);
		update_option(DD_FBSHARE_OPTIONS, $dd_fbshare->wp_options);
		update_option(DD_POLLADIUM_OPTIONS, $dd_polladium->wp_options);
		update_option(DD_STUMBLEUPON_OPTIONS, $dd_stumbleupon->wp_options);
		update_option(DD_DELICIOUS_OPTIONS, $dd_delicious->wp_options);
		update_option(DD_SPHINN_OPTIONS, $dd_sphinn->wp_options);
		update_option(DD_COMMENTS_OPTIONS, $dd_comments->wp_options);
		update_option(DD_GBUZZ_OPTIONS, $dd_gbuzz->wp_options);
		
		//update display option
	    update_option(DD_DISPLAY_HOME, $_POST[DD_DISPLAY_HOME]);
		update_option(DD_DISPLAY_PAGE, $_POST[DD_DISPLAY_PAGE]);
		update_option(DD_DISPLAY_POST, $_POST[DD_DISPLAY_POST]);
		update_option(DD_DISPLAY_CATEGORY, $_POST[DD_DISPLAY_CATEGORY]);
		update_option(DD_DISPLAY_ARCHIVE, $_POST[DD_DISPLAY_ARCHIVE]);
	
		//update line up option
		update_option(DD_LINE_UP, $_POST[DD_LINE_UP]);
		
		//update html output option
		update_option(DD_OUTPUT_HTML, $_POST[DD_OUTPUT_HTML]);
		
		//update twitter source
		update_option(DD_TWITTER_SOURCE, $_POST[DD_TWITTER_SOURCE]);
		
		echo '<div id="message" class="updated fade"><p>Updated.</p></div>';
		
  	}else if(isset($_POST[DD_FORM_CLEAR])){
	
        digg_digg_resetIt();
		echo "<div id='message' class='error fade'><p>Settings Cleared.</p></div>";
			
  	}

  	//load options from db
  	$dd_digg->wp_options = get_option(DD_DIGG_OPTIONS);
  	$dd_reddit->wp_options = get_option(DD_REDDIT_OPTIONS);
  	$dd_dzone->wp_options = get_option(DD_DZONE_OPTIONS);
  	$dd_ybuzz->wp_options = get_option(DD_YBUZZ_OPTIONS);
  	$dd_twitter->wp_options = get_option(DD_TWITTER_OPTIONS);
  	$dd_fbshare->wp_options = get_option(DD_FBSHARE_OPTIONS);
  	$dd_polladium->wp_options = get_option(DD_POLLADIUM_OPTIONS);
    $dd_stumbleupon->wp_options = get_option(DD_STUMBLEUPON_OPTIONS);
  	$dd_delicious->wp_options = get_option(DD_DELICIOUS_OPTIONS);
  	$dd_sphinn->wp_options = get_option(DD_SPHINN_OPTIONS);
  	$dd_comments->wp_options = get_option(DD_COMMENTS_OPTIONS);
  	$dd_gbuzz->wp_options = get_option(DD_GBUZZ_OPTIONS);
  
  	$dd_buttons = array($dd_digg,$dd_reddit,$dd_dzone,$dd_ybuzz,$dd_twitter,$dd_fbshare,$dd_polladium,$dd_stumbleupon,$dd_delicious,$dd_sphinn,$dd_comments,$dd_gbuzz);
  	// display admin screen
  	print_digg_digg_menu_form($dd_buttons);
  
}

/**
 * Validate whether allow the digg digg button display
 * @return true allow display, false not allow to display
 */
function digg_digg_isDisplay(){
	//get display option
    $dd_display_home = get_option(DD_DISPLAY_HOME);
	$dd_display_page = get_option(DD_DISPLAY_PAGE);
	$dd_display_post = get_option(DD_DISPLAY_POST);
	$dd_display_category = get_option(DD_DISPLAY_CATEGORY);
	$dd_display_archive = get_option(DD_DISPLAY_ARCHIVE);
	
	//TODO: can it display in feed?
	$dd_display_feed = DD_DISPLAY_OFF;

	if(is_home() && ($dd_display_home==DD_DISPLAY_ON)){
		return true;
	}else if(is_feed() && ($dd_display_feed==DD_DISPLAY_ON)){
		return true;
	}else if(is_single() && ($dd_display_post==DD_DISPLAY_ON)){
		return true;
	}else if(is_category() && ($dd_display_category==DD_DISPLAY_ON)){
		return true;
	}else if(is_page() && ($dd_display_page==DD_DISPLAY_ON)){
		return true;
	}else if(is_archive() && ($dd_display_archive==DD_DISPLAY_ON)){
		return true;
	}else{
		return false;
	}
}


/**
 * Validate whether allow the digg digg button display
 * @return true allow display, false not allow to display
 */
function digg_digg_isDisplayDisabled($content){
	
	if (preg_match("/" . DD_DISABLED . "/i", $content)) {
	    return true;
	} else {
	    return false;
	}
	
}

function digg_digg_content_hook($content = ''){

    global $wp_query;
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
 
    //allow to display?
    if(digg_digg_isDisplay()==false || digg_digg_isDisplayDisabled($content)==true){
    	return $content;
    }
    
    $dd_line_up = get_option(DD_LINE_UP);	 
    $dd_html_output = get_option(DD_OUTPUT_HTML);
    $dd_twitter_source = get_option(DD_TWITTER_SOURCE);
    
    $dd_digg = new DD_Digg();
    $dd_reddit = new DD_Reddit();
    $dd_dzone = new DD_Dzone();
    $dd_ybuzz = new DD_YBuzz();
    $dd_twitter = new DD_Twitter();
    $dd_fbshare = new DD_FbShare();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
  	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	
    $dd_digg->wp_options = get_option(DD_DIGG_OPTIONS);	 
    $dd_reddit->wp_options = get_option(DD_REDDIT_OPTIONS);	 
	$dd_dzone->wp_options = get_option(DD_DZONE_OPTIONS);
	$dd_ybuzz->wp_options = get_option(DD_YBUZZ_OPTIONS);
	$dd_twitter->wp_options = get_option(DD_TWITTER_OPTIONS);
	$dd_fbshare->wp_options = get_option(DD_FBSHARE_OPTIONS);
	$dd_polladium->wp_options = get_option(DD_POLLADIUM_OPTIONS);
	$dd_stumbleupon->wp_options = get_option(DD_STUMBLEUPON_OPTIONS);
	$dd_delicious->wp_options = get_option(DD_DELICIOUS_OPTIONS);
	$dd_sphinn->wp_options = get_option(DD_SPHINN_OPTIONS);
	$dd_comments->wp_options = get_option(DD_COMMENTS_OPTIONS);
	$dd_gbuzz->wp_options = get_option(DD_GBUZZ_OPTIONS);
	
    //generate vote link
    $dd_digg->construstURL($link[0],$title,$dd_digg->get_button_design());
    $dd_reddit->construstURL($link[0],$title,$dd_reddit->get_button_design());
    $dd_dzone->construstURL($link[0],$title,$dd_dzone->get_button_design());
    $dd_ybuzz->construstURL($link[0],$title,$dd_ybuzz->get_button_design());
    $dd_twitter->construstURL($link[0],$dd_twitter_source,$dd_twitter->get_button_design());
    $dd_fbshare->construstURL($link[0],$title,$dd_fbshare->get_button_design());
    $dd_polladium->construstURL($link[0],$title,$dd_polladium->get_button_design());
    $dd_stumbleupon->construstURL($link[0],$title,$dd_stumbleupon->get_button_design());
    $dd_delicious->construstURL($link[0],$title,$dd_delicious->get_button_design());
    $dd_sphinn->construstURL($link[0],$title,$dd_sphinn->get_button_design());
    $dd_comments->construstURL($link[0],$comments);
    $dd_gbuzz->construstURL($link[0],$title,get_bloginfo('url'),$dd_gbuzz->get_button_design());
    
	$dd_left_float = '';
	$dd_right_float = '';
	$dd_before_content = '';
	$dd_after_content = '';
	
	$dd_sorting_data = array();
	$dd_sorting_data[$dd_digg->get_button_weight().'-'.$dd_digg->name] = $dd_digg;
	$dd_sorting_data[$dd_reddit->get_button_weight().'-'.$dd_reddit->name] = $dd_reddit;
	$dd_sorting_data[$dd_dzone->get_button_weight().'-'.$dd_dzone->name] = $dd_dzone;
	$dd_sorting_data[$dd_ybuzz->get_button_weight().'-'.$dd_ybuzz->name] = $dd_ybuzz;
	$dd_sorting_data[$dd_twitter->get_button_weight().'-'.$dd_twitter->name] = $dd_twitter;
	$dd_sorting_data[$dd_fbshare->get_button_weight().'-'.$dd_fbshare->name] = $dd_fbshare;
	$dd_sorting_data[$dd_polladium->get_button_weight().'-'.$dd_polladium->name] = $dd_polladium;
	$dd_sorting_data[$dd_stumbleupon->get_button_weight().'-'.$dd_stumbleupon->name] = $dd_stumbleupon;
	$dd_sorting_data[$dd_delicious->get_button_weight().'-'.$dd_delicious->name] = $dd_delicious;
	$dd_sorting_data[$dd_sphinn->get_button_weight().'-'.$dd_sphinn->name] = $dd_sphinn;
	$dd_sorting_data[$dd_comments->get_button_weight().'-'.$dd_comments->name] = $dd_comments;
	$dd_sorting_data[$dd_gbuzz->get_button_weight().'-'.$dd_gbuzz->name] = $dd_gbuzz;
	
	//sort i
	krsort($dd_sorting_data,SORT_NUMERIC);
	
	if($dd_html_output==DD_OUTPUT_HTML_UL){
		$content = generateDiggDiggContentUL($content,$dd_sorting_data, $dd_line_up);
	}else{
		$content = generateDiggDiggContentTable($content,$dd_sorting_data, $dd_line_up);
	}
	
	
	
    return $content;
}

/**
 * Generate the final content for display
 * @param $content wordpress content
 * @param $dd_all_data button perperties
 * @param $dd_line_up button line up style
 * @return formmated content
 */
function generateDiggDiggContentUL($content,$dd_all_data, $dd_line_up){
	
	$dd_before_content = '';
	$dd_after_content = ''; 
	$dd_left_float = ''; 
	$dd_right_float = '';
	
	foreach($dd_all_data as $obj){
		if($obj->get_append_type() == DD_SELECT_LEFT_FLOAT){
			$dd_left_float .= generateList($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_RIGHT_FLOAT){
			$dd_right_float .= generateList($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_BEFORE_CONTENT){
			$dd_before_content .= generateList($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_AFTER_CONTENT){
			$dd_after_content .= generateList($obj->finalURL,$dd_line_up);
		}
	}
	
	if($dd_before_content!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_before_content = "<div id='dd_before'><ul>" . $dd_before_content. "</ul><div style=\"clear:both\"></div></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_before_content = "<div id='dd_before'><ul>" . $dd_before_content. "</ul></div>";
		}else{
			$dd_before_content = "<div id='dd_before'><ul>" . $dd_before_content. "</ul><div style=\"clear:both\"></div></div>";
		}
	}
		
	if($dd_after_content!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_after_content = "<div id='dd_after'><ul>" . $dd_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_after_content = "<div id='dd_after'><ul>" . $dd_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}else{
			$dd_after_content = "<div id='dd_after'><ul>" . $dd_after_content. "</ul></div><div style=\"clear:both\"></div>";
		}
	}
	
	if($dd_left_float!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_left_float = "<div id='dd_left'><ul>" . $dd_left_float. "</ul></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_left_float = "<div id='dd_left'><ul>" . $dd_left_float. "</ul></div>";
		}else{
			$dd_left_float = "<div id='dd_left'><ul>" . $dd_left_float. "</ul></div>";
		}
	}
		
	if($dd_right_float!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_right_float = "<div id='dd_right'><ul>" . $dd_right_float. "</ul></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_right_float = "<div id='dd_right'><ul>" . $dd_right_float. "</ul></div>";
		}else{
			$dd_right_float = "<div id='dd_right'><ul>" . $dd_right_float. "</ul></div>";
		}
	}	
	
	$content = $dd_left_float . $dd_right_float . $dd_before_content . $content . $dd_after_content . DD_AUTHOR_SITE;
	
	return $content;
}

/**
 * Generate li for display
 * @param $link button url
 * @param $dd_line_up button line up style
 * @return formatted list order 
 */
function generateList($link, $dd_line_up){
	
	if($dd_line_up==DD_LINE_UP_HORIZONTAL){
		return "<li class='li_horizontal'>" .$link. "</li>" ;
	}else if($dd_line_up==DD_LINE_UP_VERTICAL){
		return "<li class='li_vertical'>" .$link. "</li>" ;
	}else{
		return "<li class='li_horizontal'>" .$link. "</li>" ;
	}

}

/**
 * Generate the final content for display
 * @param $content wordpress content
 * @param $dd_all_data button perperties
 * @param $dd_line_up button line up style
 * @return formmated content
 */
function generateDiggDiggContentTable($content,$dd_all_data, $dd_line_up){
	
	$dd_before_content = '';
	$dd_after_content = ''; 
	$dd_left_float = ''; 
	$dd_right_float = '';
	
	foreach($dd_all_data as $obj){
		if($obj->get_append_type() == DD_SELECT_LEFT_FLOAT){
			$dd_left_float .= generateTableCells($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_RIGHT_FLOAT){
			$dd_right_float .= generateTableCells($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_BEFORE_CONTENT){
			$dd_before_content .= generateTableCells($obj->finalURL,$dd_line_up);
		}else if($obj->get_append_type() == DD_SELECT_AFTER_CONTENT){
			$dd_after_content .= generateTableCells($obj->finalURL,$dd_line_up);
		}
	}
	
	if($dd_before_content!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_before_content = "<div class='dd_before'><table><tr>" . $dd_before_content. "</tr></table></div>";	
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_before_content = "<div class='dd_before'><table>" . $dd_before_content. "</table></div>";	
		}else{
			$dd_before_content = "<div class='dd_before'><table><tr>" . $dd_before_content. "</tr></table></div>";
		}
	}
		
	if($dd_after_content!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_after_content = "<div class='dd_after'><table><tr>" . $dd_after_content. "</tr></table></div>";	
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_after_content = "<div class='dd_after'><table>" . $dd_after_content. "</table></div>";
		}else{
			$dd_after_content = "<div class='dd_after'><table><tr>" . $dd_after_content. "</tr></table></div>";
		}
	}
	
	if($dd_left_float!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_left_float = "<div class='dd_left'><table><tr>" . $dd_left_float. "</tr></table></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_left_float = "<div class='dd_left'><table>" . $dd_left_float. "</table></div>";
		}else{
			$dd_left_float = "<div class='dd_left'><table><tr>" . $dd_left_float. "</tr></table></div>";
		}
	}
		
	if($dd_right_float!=''){
		if($dd_line_up==DD_LINE_UP_HORIZONTAL){
			$dd_right_float = "<div class='dd_right'><table><tr>" . $dd_right_float. "</tr></table></div>";
		}else if($dd_line_up==DD_LINE_UP_VERTICAL){
			$dd_right_float = "<div class='dd_right'><table>" . $dd_right_float. "</table></div>";
		}else{
			$dd_right_float = "<div class='dd_right'><table><tr>" . $dd_right_float. "</tr></table></div>";
		}
	}	
	
	$content = $dd_left_float . $dd_right_float . $dd_before_content . $content . $dd_after_content . DD_AUTHOR_SITE;
	
	return $content;
}

/**
 * Generate table cells for display
 * @param $link button url
 * @param $dd_line_up button line up style
 * @return formatted table cell 
 */
function generateTableCells($link, $dd_line_up){
	
	if($dd_line_up==DD_LINE_UP_HORIZONTAL){
		return "<td>" .$link. "</td>" ;
	}else if($dd_line_up==DD_LINE_UP_VERTICAL){
		return "<tr><td>" .$link. "</td></tr>" ;
	}else{
		return "<td>" .$link. "</td>" ;
	}
	
}
	

/***********************************Advance Usage*********************************/

/**
 * Generate Digg button link
 * @param $buttonDesign Normal or Compact
 * @return Digg button link
 */
function digg_digg_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_digg = new DD_Digg();
    $dd_digg->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_digg->finalURL;
}	

/**
 * Generate Reddit button link
 * @param $buttonDesign Normal or Compact
 * @return Reddit button link
 */
function digg_digg_reddit_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_reddit = new DD_Reddit();
    $dd_reddit->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_reddit->finalURL;
}

/**
 * Generate Dzone button link
 * @param $buttonDesign Normal or Compact
 * @return Dzone button link
 */
function digg_digg_dzone_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_dzone = new DD_Dzone();
    $dd_dzone->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_dzone->finalURL;
}

/**
 * Generate YBuzz button link
 * @param $buttonDesign Normal or Compact
 * @return YBuzz button link
 */
function digg_digg_ybuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_ybuzz = new DD_YBuzz();
    $dd_ybuzz->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_ybuzz->finalURL;
}

/**
 * Generate Twitter button link
 * @param $buttonDesign Normal or Compact
 * @return Twitter button link
 */
function digg_digg_twitter_generate($buttonDesign='Normal', $source=''){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_twitter = new DD_Twitter();
    $dd_twitter->construstURL($link[0],$source,$buttonDesign);
    
	echo $dd_twitter->finalURL;
}

/**
 * Generate Facebook button link
 * @param $buttonDesign Normal or Compact
 * @return Facebook button link
 */
function digg_digg_fbshare_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fbshare = new DD_FbShare();
    $dd_fbshare->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_fbshare->finalURL;
}


/**
 * Generate Polladium button link
 * @param $buttonDesign Normal or Compact
 * @return Polladium button link
 */
function digg_digg_poll_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_polladium = new DD_Polladium();
    $dd_polladium->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_polladium->finalURL;
}
	

/**
 * Generate StumbleUpon button link
 * @param $buttonDesign Normal or Compact
 * @return StumbleUpon button link
 */
function digg_digg_stumbleupon_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_stumbleupon = new DD_StumbleUpon();
    $dd_stumbleupon->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_stumbleupon->finalURL;
}	

/**
 * Generate Delicious button link
 * @param $buttonDesign Normal or Compact
 * @return Delicious button link
 */
function digg_digg_delicious_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_delicious = new DD_Delicious();
    $dd_delicious->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_delicious->finalURL;
}	


/**
 * Generate Sphinn button link
 * @param $buttonDesign Normal or Compact
 * @return Sphinn button link
 */
function digg_digg_sphinn_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_sphinn = new DD_Sphinn();
    $dd_sphinn->construstURL($link[0],$title,$buttonDesign);
    
	echo $dd_sphinn->finalURL;
}	


/**
 * Generate post comments button link
 * @param $buttonDesign Normal or Compact
 * @return Post comments button link
 */
function digg_digg_post_comments_generate(){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_comments = new DD_Comments();
    $dd_comments->construstURL($link[0],$comments);
    
	echo $dd_comments->finalURL;
}	

/**
 * Generate Google Buzz button link
 * @param $buttonDesign Normal or Compact
 * @return GBuzz button link
 */
function digg_digg_gbuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_gbuzz = new DD_GBuzz();
    $dd_gbuzz->construstURL($link[0],$title,get_bloginfo('url'),$buttonDesign);
    
	echo $dd_gbuzz->finalURL;
}


?>